/*
 * systick.cpp
 *
 *  Created on: 2011/08/11
 *      Author: atsu
 */

#include "systick.h"


static unsigned long msTicks;                            /* counts 1ms timeTicks */
/*------------------------------------------------------------------------------
  delays number of tick Systicks (happens every 1 ms)
 *------------------------------------------------------------------------------*/
void delay (unsigned long dlyTicks) {
  unsigned long curTicks;

  curTicks = msTicks;
  while ((msTicks - curTicks) < dlyTicks);
}


unsigned long millis(void)
{
	return msTicks;
}
/*----------------------------------------------------------------------------
  SysTick_Handler
 *----------------------------------------------------------------------------*/
void SysTick_Handler(void) {
  msTicks++;                        /* increment counter necessary in Delay() */
}

void setup_systick (void) {

	//LPC_SYSCON->SYSAHBCLKCTRL |= (1<<6);

	// Setup SysTick Timer for 1 msec interrupts
	// Configure System tick timer in 10msec period
	unsigned long period = SystemCoreClock / 1000;     // Period for 1msec SYSTICK
	SysTick_Config(period);             // Configuration

#if 1
  if ( !(SysTick->CTRL & SysTick_CTRL_CLKSOURCE_Msk) )
  {
	/* When external reference clock is used(CLKSOURCE in
	Systick Control and register bit 2 is set to 0), the
	SYSTICKCLKDIV must be a non-zero value and 2.5 times
	faster than the reference clock.
	When core clock, or system AHB clock, is used(CLKSOURCE
	in Systick Control and register bit 2 is set to 1), the
	SYSTICKCLKDIV has no effect to the SYSTICK frequency. See
	more on Systick clock and status register in Cortex-M3
	technical Reference Manual. */
	LPC_SYSCON->SYSTICKCLKDIV = 0x08;
  }
#endif
}

